package quota.quota;

import java.io.File;
import java.nio.file.Files;

import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;

public class DirectoryLister
{
    private File startingPoint;
    private JProgressBar progressBar;
    private long taille;
    
    public DirectoryLister(String path) {
        this.startingPoint = new File(path);
    }
    
    public DirectoryLister(String path, JProgressBar progressBar) {
        this.startingPoint = new File(path);
        this.progressBar = progressBar;
    }

    public long list()
    {
        return recursiveList(startingPoint, "");
    }
    
    public long list(SortedListModel<FileItem> listModel)
    {
    	return recursiveList(this.startingPoint, listModel);
    }
/*
    public static void main(String[] args) {
        DirectoryLister lister = new DirectoryLister("/usr/share/icons");
        long totalSize = lister.list();
        System.out.println("Taille totale : " + (totalSize / (1024 * 1024)) + " Mo");

    }*/

    private long recursiveList(File f, String indent)
    {
    	File[] tabFile = f.listFiles();
        for(int i = 0; tabFile!=null && i < tabFile.length; i++)
        {
        	if (Files.isSymbolicLink(tabFile[i].toPath())) continue;
        	if(tabFile[i].isDirectory())
            {
            	System.out.println(indent + "+" + tabFile[i].getName());
            	/*this.taille = this.taille + */recursiveList(tabFile[i], indent + "  ");
            }
        	else
        	{
        		System.out.println(indent + tabFile[i].getName());
        		this.taille = this.taille + tabFile[i].length();
        	}
        	this.updateProgress(this.taille);
		}
    	return this.taille;
    }
    
    private long recursiveList(File f, SortedListModel<FileItem> listModel)
    {
    	File[] tabFile = f.listFiles();
        for(int i = 0; tabFile!=null && i < tabFile.length; i++)
        {
        	FileItem fi = new FileItem(tabFile[i]);
        	if (Files.isSymbolicLink(tabFile[i].toPath())) continue;
        	if(tabFile[i].isDirectory())
            {
            	recursiveList(tabFile[i], listModel);
            }
        	else
        	{
        		if (tabFile[i].length()>=10240)
        		{
        			/*
        			 * SwingUtilities.invokeLater sert a donner l'instruction listModel.add(fi)
        			 * au thread cree automatiquement par swing qui se nomme EDT
        			 * Comme ça on peut relancer le boutton sans que ça plante car sa s'ajoute
        			 * tjrs à l'EDT
        			 */
        			SwingUtilities.invokeLater(() -> listModel.add(fi));
        		}
        		this.taille = this.taille + tabFile[i].length();
        	}
        	this.updateProgress(this.taille);
		}
    	return this.taille;
    }

    private void updateProgress(long sizeInBytes)
    {
		long l = sizeInBytes/(1024 * 1024);
		this.progressBar.setString(l + " Mo");
		this.progressBar.setValue((int)(l));
    }
}