package quota.quota;

import java.io.File;

/**
 * Classe représentant un fichier et destinée à être utilisée par un modèle de liste
 * de type SortedListModel (l'ordre étant défini par l'ordre inverse des tailles des
 * fichiers représentés.
 */        
public class FileItem implements Comparable<FileItem>{
    
    // taille en octets du fichier représenté par cet objet
    private long size;
    
    // chaîne de caractères contenant la taille et le chemin du fichier
    private String string;

    public FileItem(File file)
    {
        this.size = file.length();
        this.string = file.getName();
    }

    /**
     * comparaison de deux objets de type FileItem.
     * L'ordre est l'ordre inverse des tailles des fichiers représentés par ces objets.
     * @param o objet à comparer à l'objet courant
     * @return un entier négatif, nul ou positif si la taille du fichier représenté par
     * l'objet courant est respectivement supérieure, égale ou inférieure à la taille du
     * fichier représenté par l'objet o.
     */
    public int compareTo(FileItem o)
    {
        return 1;
    }

    @Override
    public String toString()
    {
        return string;
    }
}