package quota.quota;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.util.GregorianCalendar;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;

public class QuotaFrame extends JFrame
{
	
	/**
	 * backgroundPool est un new thread qu'on a cree pour les autres instructions
	 * qu'on a à lui donner, autre que les truc visuel car ça c'est le thread EDT qui va les
	 * gérer donc là on en a 2 thread : EDT pour les trucs visuel et backgroundPool pr le reste
	 */
	private ExecutorService backgroundPool = Executors.newSingleThreadExecutor();
	
    public QuotaFrame(int quotaInMB)
    {
		this.setTitle("Quota");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		JPanel panel = new JPanel(new GridLayout(0, 1));
		JProgressBar jpb = new JProgressBar();
		jpb.setStringPainted(true);
		jpb.setMinimum(0);
		jpb.setMaximum(quotaInMB);
		panel.add(jpb);
		
		JList<FileItem> listeFI = new JList<FileItem>();
		SortedListModel<FileItem> listeModelFI = new SortedListModel<FileItem>();
		
		
		listeFI.setModel(listeModelFI);
    	JScrollPane scrollPane = new JScrollPane(listeFI);
		
		JButton button1 = new JButton("Lancer l'opération");
		//lambda
		button1.addActionListener
    	(e ->
	    	{
	    		jpb.setIndeterminate(false);
	    		button1.setEnabled(false);
	    		DirectoryLister d = new DirectoryLister(System.getProperty("user.home"),jpb);
	    		this.backgroundPool.execute(new Runnable(){
	    			public void run()
	    			{
	    				d.list(listeModelFI);
	    				//d.list();
	    				button1.setEnabled(true);
	    			}
	    		});
			}
		);
		panel.add(button1);
		this.add(scrollPane);
		this.add(panel, BorderLayout.SOUTH);
		this.pack();
    }

    public static void main(String[] args)
    {
    	/*
    	 * Anonyme
        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                new QuotaFrame(100).setVisible(true);
            }
        });
        */
    	//Lambda
        SwingUtilities.invokeLater(() -> new QuotaFrame(0).setVisible(true));
    }
}
